# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2014-TODAY Eynes (<http://www.e-mips.com.ar>)
#
#    This is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import psycopg2
import logging

logger = logging.getLogger(__name__)


def _do_update(cr, installed_version):
    try:
        logger.info('Backup pos_order amount_total in old_amount_total_bi')
        cr.execute("ALTER TABLE pos_order ADD COLUMN old_amount_total_bi numeric")
        cr.execute("UPDATE pos_order SET old_amount_total_bi=amount_total")
        logger.info('Backup account.invoice pos_order_id in old_pos_order_id')
        cr.execute("ALTER TABLE account_invoice ADD COLUMN old_pos_order_id INTEGER")
        cr.execute("UPDATE account_invoice SET old_pos_order_id=pos_order_id")
    except psycopg2.ProgrammingError as e:
        logger.warning(e)
        cr.rollback()
    except Exception as e:
        logger.warning(e)
        cr.rollback()
    else:
        cr.commit()

    logger.info("Drop financing_config's financing_config_uniq_quota_qty_product constraint.")
    try:
        cr.execute("ALTER TABLE financing_config DROP CONSTRAINT financing_config_uniq_quota_qty_product")
    except psycopg2.ProgrammingError:
        cr.rollback()
    else:
        cr.commit()


def migrate(cr, installed_version):
    return _do_update(cr, installed_version)
