# -*- coding: utf-8 -*-
from openerp import models, fields, api, _, exceptions, http
from openerp.http import request as rq
import logging

_logger = logging.getLogger(__name__)


try:
    from easywsy import WebService, wsapi
except (ImportError, IOError) as e:
    class wsapi:
        def check(*a, **kw):
            def func(*a, **kw):
                return None
            return func

    WebService = object
    _logger.debug("Cannot import WebService, wsapi from easywsy: \n%s" %
                  repr(e))


class WSCPZ(WebService):

    def __init__(self, env, *args, **kwargs):
        assert(isinstance(env, api.Environment)), 'Bad environment'
        self.odooenv = env
        self.conf_obj = env['ir.config_parameter'].sudo()
        ws_url = (self.conf_obj.get_param('financing.ws.url') or
                'https://aplicaciones.credipaz.com:3456/wsMIL/wsMIL.asmx')
        if '?wsdl' not in ws_url:
            ws_url += '?wsdl'
        super(WSCPZ, self).__init__(ws_url, *args, **kwargs)

    @property
    def ws_user(self):
        return self.conf_obj.get_param('financing.ws.user')

    @property
    def ws_pass(self):
        return self.conf_obj.get_param('financing.ws.pass')

    @property
    def ws_pin(self):
        return self.conf_obj.get_param('financing.ws.pin')

    def request(self, method_name):
        param_url = self.conf_obj.get_param('web.base.url')
        rqurl = rq.httprequest.url
        # if ('staging' in param_url + rqurl) or ('localhost' in param_url + rqurl):
        #     _logger.warning('Running in debug mode, request will not be send.')
        #     # if method_name == 'ConsultarDisponible':
        #     #     mock_d = {
        #     #         'Credito'
        #     #     }
        # else:
        res = super(WSCPZ, self).request(method_name)
        if not res:
            raise Exception('WS returned no data')
        return res

