/******************************************************************************
 *    Financing - Financing on Odoo
 *    Copyright (C) 2017 Eynes
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU Affero General Public License as
 *    published by the Free Software Foundation, either version 3 of the
 *    License, or (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************/

function financing_db(instance, module) {

    var PosDBParent = module.PosDB;
    var round_di = instance.web.round_decimals;
    var round_pr = instance.web.round_precision;
    module.PosDB = module.PosDB.extend({

        init: function (options) {
            options = options || {};
            this._super(options);
            this.financing_by_product_id = {};
            this.remove_all_orders();
            // ^-- Credipaz orders are to invoice only, so when starting up pos clear all in db
        },
        
        add_partners: function(partners){  // prevent pos from viewing false as string in partner creation
            var self = this;
            for (var i = 0, len = partners.length; i < len; i++) {
                p = partners[i];
                for (var key in p){
                    if (p.hasOwnProperty(key)) {
                        if (p[key] === false) {
                            p[key] = "";
                        }
                    }
                }
            }
            res = this._super(partners);
            return res
        },
        add_products_with_pos: function (products, pos_model) {
            this.add_products(products);
            if (!products instanceof Array) {
                products = [products];
            }
            tax_obj = {};
            for (var i = 0, len = pos_model.taxes.length; i < len; i++) {
                tax_obj[pos_model.taxes[i].id] = pos_model.taxes[i];
            }
            for(var i = 0, len = products.length; i < len; i++){
                var product = products[i];
                var product_id = product.id;

                try {
                    var tax_to_apply = tax_obj[product.taxes_id[0]];
                    product.price_with_taxes = product.price * (1 + tax_to_apply.amount);
                } catch (e) {
                    /* handle error */
                    console.warn(product);
                }
            }
        },
    });
}
