# -*- coding: utf-8 -*-
from openerp.exceptions import except_orm, ValidationError
from openerp.tests.common import TransactionCase
from openerp import fields
from datetime import datetime, timedelta, date
from tempfile import TemporaryFile
import logging
import pytest

class TestWizardFinancingPriceQuery(TransactionCase):
    def tearDown(self):
        super(TestWizardFinancingPriceQuery, self).tearDown()

    def setUp(self):
        super(TestWizardFinancingPriceQuery, self).setUp()
        self.cr.execute('delete from financing_config')
        translate_logger = logging.getLogger('openerp.tools.translate')
        translate_logger.setLevel('INFO')  # mute translations
        self.fc_model = self.env['financing.config']
        self.journal = self.browse_ref('financing.card_journal01')
        self.pl0 = self.browse_ref('product.list0')
        self.pl1 = self.browse_ref('financing.list1')
        self.card01 = self.browse_ref('financing.card01')
        self.card02 = self.browse_ref('financing.card02')
        self.pos_config_main = self.browse_ref('point_of_sale.pos_config_main')
        self.pos_config_main2 = self.ref('financing.pos_config_main2')
        self.wiz_model = self.env['financing.price.query']

    def test_wizard_simple_price_generation_line(self):
        """
        Different monthly rates for same quota should raise exception
        """
        self.fcgeneric_ass = self.fc_model.create({
            'journal_id': self.ref('financing.card_journal01'),
            'customer_type': 'associated',
            'quota_qty': 1,
            'monthly_rate': 0.4,
            'card_ids': [(6, 0, [self.ref('financing.card01')])],
        })
        mywiz = self.wiz_model.create({
            'product_ids': [(6, 0, [self.ref('product.product_product_4')])],
        })
        mywiz.generate()
        assert len(mywiz.item_ids) == 2
        product = self.browse_ref('product.product_product_4')
        for item in mywiz.item_ids:
            price_with_coeff = product.with_context(pricelist=item.pricelist_id.id).price * 1.4
            assert item.financed_price == price_with_coeff
